import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { BookingOrderInfo, BookingOrderInfoParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageBookingOrderInfo(params: BookingOrderInfoParam) {
  const res = await request.get<ApiResult<PageResult<BookingOrderInfo>>>(
    MODULES_API_URL + '/booking/booking-order-info/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listBookingOrderInfo(params?: BookingOrderInfoParam) {
  const res = await request.get<ApiResult<BookingOrderInfo[]>>(
    MODULES_API_URL + '/booking/booking-order-info',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addBookingOrderInfo(data: BookingOrderInfo) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-order-info',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateBookingOrderInfo(data: BookingOrderInfo) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-order-info',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeBookingOrderInfo(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-order-info/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchBookingOrderInfo(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-order-info/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getBookingOrderInfo(id: number) {
  const res = await request.get<ApiResult<BookingOrderInfo>>(
    MODULES_API_URL + '/booking/booking-order-info/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
